pro getgrid, grid, levels=levels, dir=dir, ghosts=ghosts, cpu=cpu, axes=axes, help=help
mesh_color=[[0,0,0],[255,0,0],[0,255,0],[0,0,255],[255,255,0],[255,0,255],[0,255,255]]
if not(keyword_set(dir)) then dir = '.'
if (n_elements(levels) EQ 0) then levels=indgen(1000)-10
levels = [levels]
strres = findfile (filepath('fulldesc*_*.dat', ROOT_dir='.', SUBDIR=dir))
if ((size(strres))(0) EQ 0) then begin
    print, "No matching descriptor found."
    return
endif
grid = obj_new('IDLgrModel')
nb = (size(strres))(1)
found = 0
for i=0,nb-1 do begin
    name=strres(i)
;    print,name
    level= long(strmid(name,strpos(name, "_")+1))
    descnb = long(strmid(name,strpos(name, "fulldesc")+8))
;    print,descnb,level,min(levels),max(levels)
    if ((level GE min(levels)) AND (level LE max(levels))) then begin
        found = found+1
        read_desc, desc=descnb, coordtype=ctype, coordpermut=cpermut,$
edge1=e1,edge2=e2,edge3=e3,size=size,/fast
        er1=e1(2:size[0]+2)
        er2=e2(2:size[1]+2)
        er3=e3(2:size[2]+2)
        subgrid = obj_new('FMgrMesh',er1,er2,er3,meshtype=ctype,$
/boundary, color=mesh_color(*,min([level,(size(mesh_color))(1)])));
        if keyword_set(ghosts) then begin
            subgridg = obj_new('FMgrMesh',e1,e2,e3,meshtype=ctype,$
/boundary, color=mesh_color(*,min([level,(size(mesh_color))(1)])),$
linestyle=2);
            grid->Add, subgridg
        endif
        grid->Add, subgrid
    endif
endfor
print, "found = ",found
return
end
