pro polar_vf, n=n, genlist=genlist, path=path, field, quiet=quiet,$
                 zslice = zslice, xrange=xrange, yrange=yrange,$
                 show=show, _EXTRA=e_e
   if keyword_set (n) then n=n else n=0
   if keyword_set (genlist) then descriptornumber=descriptornumber else genlist=[1,1,1,1,1,1,1]
   if keyword_set (path) then path=path else path='../out/test_2d/protoplanet'
   if keyword_set (quiet) then verbose = 0 else verbose = 1
   if keyword_set (zslice) then zslice=zslice else zslice = 0.0
   if keyword_set (show) then show = 1 else show = 0
   descfile =strcompress('gasvelocity'+string(n)+'_*_*.dat', /remove_all)
   strres = findfile (filepath(descfile, ROOT_dir='.', SUBDIR=path))
   if ((size(strres))(0) EQ 0) then begin
       r = dialog_message(generic_filename+' does not exist in '+path, /error, title='Warning')
       return
   endif
   nb = (size(strres))(1)
   vx_set = [0]
   vy_set = [0]
   x_set = [0]
   y_set = [0]
   thetamin = 1e20
   thetamax = -1e20
   rmin = 1e20
   rmax = -1e20
   for i=nb-1, 0, -1 do begin       ; We need to read the highest first
       current_name = strres(i)
       c1 = strpos(current_name, '_', /reverse_search)
       c2 = strpos(strmid(current_name, 0, c1-1), '_',/reverse_search)
       descnumber = long(strmid(current_name, c2+1))
       read_field, n=n, radix='velocity', component=0,$
         descriptornumber=descnumber, path=path, vt, theta, r, z, /quiet, bounds
       read_field, n=n, radix='velocity', component=1,$
         descriptornumber=descnumber, path=path, vr, theta, r, z, /quiet, bounds
       print, bounds
       nt = (size(vt))(1)
       nr = (size(vt))(2)
       if (descnumber EQ 0) then begin 
           vt(*,0,0) = 0.0
           vr(*,0,0) = 0.0
       endif
       if ((zslice GE bounds(4)) AND (zslice LE bounds(5)) AND (genlist(i) NE 0)) then begin
           tt = replicate (1, nr, 1) ## theta
           rr = r ## replicate (1, nt, 1)
           b = where ((tt LT thetamin) OR (tt GT thetamax) $
                      OR (rr LT rmin) OR (rr GT rmax))
           vx = vr(b)*cos(tt(b))-vt(b)*sin(tt(b))
           vy = vr(b)*sin(tt(b))+vt(b)*cos(tt(b))
           xr = rr(b)*cos(tt(b))
           yr = rr(b)*sin(tt(b))
           vx_set = [vx_set, vx]
           vy_set = [vy_set, vy]
           x_set = [x_set, xr]
           y_set = [y_set, yr]
           thetamin = min(theta)
           thetamax = max(theta)
           rmin = min(r)
           rmax = max(r)
       endif
   endfor
   vx_set = vx_set(1:*)
   vy_set = vy_set(1:*)
   x_set = x_set(1:*)
   y_set = y_set(1:*)
   triangulate, x_set,y_set,tr,b
   if (n_elements(xrange) EQ 0) then xrange=[min(x_set),max(x_set)]
   if (n_elements(yrange) EQ 0) then yrange=[min(y_set),max(y_set)]
   vx = trigrid(x_set,y_set,vx_set,tr,[(xrange(1)-xrange(0))/50.0,(yrange(1)-yrange(0))/50.0],$
                [xrange(0),yrange(0),xrange(1),yrange(1)], xgrid=x, ygrid=y)
   vy = trigrid(x_set,y_set,vy_set,tr,[(xrange(1)-xrange(0))/50.0,(yrange(1)-yrange(0))/50.0],$
                [xrange(0),yrange(0),xrange(1),yrange(1)], xgrid=x, ygrid=y)
   velovect,vx,vy,x,y,_extra=e_e,xr=[xrange(0),xrange(1)],yr=[yrange(0),yrange(1)]
   if (show EQ 1) then begin
       for i=nb-1, 0, -1 do begin ; We now display the grid limits
           current_name = strres(i)
           c1 = strpos(current_name, '_', /reverse_search)
           c2 = strpos(strmid(current_name, 0, c1-1), '_',/reverse_search)
           descnumber = long(strmid(current_name, c2+1))
           read_field, n=n, radix=radix, component=component,$
             descriptornumber=descnumber, path=path, f, theta, r, z, /quiet, bounds
           if ((zslice GE bounds(4)) AND (zslice LE bounds(5)) AND (genlist(i) NE 0)) then begin
               tmin = bounds(0)
               tmax = bounds(1)
               rmin = bounds(2)
               rmax = bounds(3)
               x = rmax*cos(tmin)
               y = rmax*sin(tmin)
               plots,x,y
               for j=0,1000 do begin
                   theta=(tmax-tmin)*j/1e3+tmin
                   x=rmin*(cos(theta))
                   y=rmin*(sin(theta))
                   plots,x,y,/continue
               endfor
               for j=0,1000 do begin
                   theta=(tmin-tmax)*j/1e3+tmax
                   x=rmax*(cos(theta))
                   y=rmax*(sin(theta))
                   plots,x,y,/continue
               endfor
           endif
       endfor
   endif
return
end
