pro readstruct, nb=nb, dir=dir,force=force
common HD_param, str_par
nbdef = 0
dirdef = '.'
read_info_dir = 0           
read_info_grid = 0       
valid_dir=1
valid_grid=1 
sd=0   
; Now before possibly applying default values we check whether
; they already exist in the STR_PAR structure, in which case they
; are "sticky"
help,str_par,/struct,output=test
;We check that the 'directory' field exists in that structure
if ((total(strpos(test,"DIRECTORY"))+(size(test))(1)) NE 0) then begin
    dirdef = str_par.directory
endif else begin
    read_info_dir = 1
endelse
;We check that the 'noutput' field exists in that structure
if ((total(strpos(test,"NOUTPUT"))+(size(test))(1)) NE 0) then begin
    nbdef = str_par.noutput
endif else begin
    read_info_grid = 1
endelse
; If no fully valid directory information had been read previously,
; we try again
if ((total(strpos(test,"VALIDDIR"))+(size(test))(1)) NE 0) then begin
    if (str_par.validdir EQ 0) then read_info_dir=1
endif
if ((total(strpos(test,"VALIDGRID"))+(size(test))(1)) NE 0) then begin
    if (str_par.validgrid EQ 0) then read_info_grid=1
endif
if ((total(strpos(test,"SGRID"))+(size(test))(1)) NE 0) then begin
    sg = str_par.sgrid
endif
if ((total(strpos(test,"SDIR"))+(size(test))(1)) NE 0) then begin
    sd = str_par.sdir
endif
lgr = -999999D0
if ((total(strpos(test,"LASTGRIDREAD"))+(size(test))(1)) NE 0) then begin
    lgr = str_par.lastgridread
endif
if (n_elements(nb) EQ 0) then nb=nbdef
if (n_elements(dir) EQ 0) then dir=dirdef
if (nb NE nbdef) then read_info_grid = 1
if (dir NE dirdef) then read_info_dir = 1
if keyword_set(force) then read_info_dir = 1
if (read_info_dir) then read_info_grid = 1
; Last, if the read_info_grid is still FALSE, we now determine the
; date at which the adequate "Descriptor[i].dat" file was last read,
; and we check whether the actual version is younger. Otherwise we force
; a new reading.
if (read_info_grid EQ 0) then begin
    filename=strcompress("Descriptor"+string(nb)+".dat",/remove_all)
    file=filepath(filename,root_dir='.',subdir=str_par.sgrid.subdir)
    res=file_info(file)
    jdlw = res.ctime
    if (jdlw GE lgr) then begin
        print,"Descriptor file is more recent than last read. Re-read forced."
        read_info_grid=1
    endif
endif
; 
;
; We read the directory information (input parameters + endian swap flag)
;
;
if (read_info_dir) then begin
    readstruct_dir, dir, sd, valid_dir
    str_par = {validdir:valid_dir,validgrid:valid_grid,directory:dir,$
noutput:nb,sgrid:0,lastgridread:lgr,sdir:sd}
endif
;
; We now read the grid structure
;
if (read_info_grid) then begin
    readstruct_grid, dir, nb, sg, valid_grid
    if (valid_grid) then begin
        lgr = systime(1)
    endif
endif
str_par = {validdir:valid_dir,validgrid:valid_grid,directory:dir,$
noutput:nb,sgrid:sg,lastgridread:lgr,sdir:sd}
return
end
