pro readstruct_dir, dir, sd, valid
    ; We read the directory 'dir' information
    ; Do we have a preformatted input file parameter ?
    print, "Reading directory wide information"
    input_par = ''
    valid=1
    inp = filepath('IDL_params.dat',root_dir='.',subdir=dir)
    res=findfile(inp, count=c)
    if (c NE 0) then begin
        spawn,"cp "+inp+" _tempo_IDL_batch"
        resolve_routine,'getinputparam'
        getinputparam, input_par
        spawn, "rm -f _tempo_IDL_batch"
    endif else begin
        print, "Warning: no IDL_params.dat found in target directory"
        valid = 0
    endelse
    ; We try to know whether we have to swap endians
    d=-2.3D0 ; if no test file exists we do not swap endians
    swap_endian=0
    openr,1,filepath('testendian.dat',root_dir='.',subdir=dir), err=err
    if (err EQ 0) then begin
        readu,1,d
        close,1
    endif else begin
        print, "Warning: no testendian.dat found in target directory"
        print, "Assuming no endian swap"
        valid = 0
    endelse
    if (abs(d+2.3) GT 1d-6) then swap_endian=1
    sd = {directory:dir,in:input_par,swap_endian:swap_endian}
return
end
