pro readstruct_grid, dir, nb, sg, valid
common HD_param, str_par
print, "Reading grid information"
file=strcompress("Descriptor"+string(nb)+".dat",/remove_all)
nbch = strcompress(string(nb),/remove_all)
outd = strmid("output00000",0,11-strlen(nbch))+nbch
subdir = dir+'/'+outd
desc=filepath(file,root_dir='.',subdir=subdir)
res = findfile(desc, count=c)
valid=1
sg=0
maxlevel=0
if (c EQ 0) then begin
    print, ""
    print, "WARNING: no valid "+file+" found in target directory"
    print, ""
    valid = 0
endif else begin
    openr,1,desc
    readf,1,date,noutput
    if (noutput NE nb) then print, "Warning : internal 'noutput' mismatch"
    readf,1,ndim,coordtype
    readf,1,ngrid,ncpu,ngh,nvar
    edges = dblarr(ngrid,3,2)
    nx = lonarr(ngrid)
    ny = lonarr(ngrid)
    nz = lonarr(ngrid)
    iface = lonarr(ngrid,3,2)
    ncorner_min = lonarr(ngrid,3)
    ncorner_max = lonarr(ngrid,3)
    gncorner_min = lonarr(ngrid,3)
    gncorner_max = lonarr(ngrid,3)
    varname=strarr(nvar)
    cpugsize = lonarr(ngrid*ncpu,3)
    cpunb = lonarr(ngrid)
    cpurank = lonarr(ngrid*ncpu)
    parent = lonarr(ngrid*ncpu)
    cgridlevel = lonarr(ngrid*ncpu)
    cgridnumber = lonarr(ngrid*ncpu)
    igrid = lonarr(ngrid)
    level = lonarr(ngrid)
    pcorner_min = lonarr(ngrid*ncpu,3)
    pcorner_max = lonarr(ngrid*ncpu,3)
    icpuface = lonarr(ngrid*ncpu,3,2)
    nb_cpu_grids=0
    for i=0,nvar-1 do begin
        line=''
        readf,1,line
        varname(i)=line
    endfor
    for i=0, ngrid-1 do begin
        readf,1,iigrid,llevel,ncpu_grid
        readf,1,nnx,nny,nnz
        it= lonarr(3,2)
        readf,1,it
        nx(i) = nnx
        ny(i) = nny
        nz(i) = nnz
        iface(i,*,*)=it
        ex1 = ngh
        ex2 = ngh;*(ndim GT 1)
        ex3 = ngh;*(ndim EQ 3)
        edges_x = dblarr(nnx+ex1*2+1)
        edges_y = dblarr(nny+ex2*2+1)
        edges_z = dblarr(nnz+ex3*2+1)
        readf,1,edges_x,edges_y,edges_z
        size_to_achieve=max([nnx+ex1*2+1,nny+ex2*2+1,nnz+ex3*2+1])
        actual_size = (size(edges))(3)
        if (size_to_achieve GT actual_size) then begin
            new_edges = dblarr(ngrid,3,size_to_achieve)
            new_edges(*,*,0:actual_size-1)=edges
            edges = new_edges
        endif
        edges(i,0,0:nnx+ex1*2) = edges_x
        edges(i,1,0:nny+ex2*2) = edges_y
        edges(i,2,0:nnz+ex3*2) = edges_z
        nc_min = lonarr(3)
        nc_max = lonarr(3)
        gnc_min = lonarr(3)
        gnc_max = lonarr(3)
        readf,1,nc_min, nc_max
        readf,1,gnc_min, gnc_max
        ncorner_min(i,*)=nc_min
        ncorner_max(i,*)=nc_max
        gncorner_min(i,*)=gnc_min
        gncorner_max(i,*)=gnc_max
        cpunb(i) = ncpu_grid
        igrid(i) = long(iigrid)
        level(i) = long(llevel)
        if (llevel GT maxlevel) then maxlevel = llevel
        for j=0, ncpu_grid-1 do begin
            readf,1,cnx,cny,cnz, cpunumber, cgnumber
            pc_min = lonarr(3)
            pc_max = lonarr(3)
            icgface = lonarr(3,2)
            readf,1,pc_min,pc_max
            readf,1,icgface
            icpuface(nb_cpu_grids,*,*)=icgface
            pcorner_min(nb_cpu_grids,*)=pc_min
            pcorner_max(nb_cpu_grids,*)=pc_max
            cpugsize(nb_cpu_grids,*)=[long(cnx),long(cny),long(cnz)]
            cpurank(nb_cpu_grids) = cpunumber
            cgridnumber(nb_cpu_grids) = cgnumber
            cgridlevel(nb_cpu_grids) = level(i)
            parent(nb_cpu_grids) = i
            nb_cpu_grids=nb_cpu_grids+1
        endfor
    endfor
    close,1
    coordname=[["X","Y","Z"],["Radius","Azimuth","Z"],["Radius","Azimuth","Co-latitude"]]
    cpermut = str_par.sdir.in.coordpermut
    invcoordnb = lonarr(3)
    for i=0,2 do begin
        invcoordnb[i] = byte(strmid(cpermut,i,1))-byte('1')
    endfor
    coordnb=invcoordnb
    coordnb[0] = where(invcoordnb EQ 0)
    coordnb[1] = where(invcoordnb EQ 1)
    coordnb[2] = where(invcoordnb EQ 2)
    name=reform(coordname[invcoordnb,long(coordtype)])
    sg = {noutput:nb,$
valid:valid, varname:varname,$
ndim:long(ndim),date:date,coordtype:long(coordtype),ngrid:long(ngrid),ncpu:long(ncpu),$
nvar:long(nvar),nghost:long(ngh),edges:edges,nx:nx,ny:ny,nz:nz,iface:iface,$
ncorner_min:ncorner_min,ncorner_max:ncorner_max,gncorner_min:gncorner_min,$
gncorner_max:gncorner_max,pcorner_min:pcorner_min,pcorner_max:pcorner_max,level:level,$
cpugsize:cpugsize,cpurank:cpurank,nb_cpu_grids:nb_cpu_grids,icpuface:icpuface,parent:parent,$
cgridlevel:cgridlevel,cgridnumber:cgridnumber,maxlevel:maxlevel,coordname:name,coordnb:coordnb,$
invcoordnb:invcoordnb,subdir:subdir,dir:dir}
endelse
return
end
