pro ring, nu, t, x, sigma, t0=t0, plot=plot, overplot=overplot, _extra=e
;+
; t and nu are the parameters.  x is given by the user and the
; procedure returns sigma(x). the ring is assumed to be centered on
; r=1, and to have unit mass.  This procedure needs a tabbessel.dat
; file to work.  This file should be an ascii file with two columns of
; numbers: the first column contains log_10 (x), the second column
; contains log_e [BesselI[1/4,x]]. The tabulated function is considered
; as a constant beyond the limits found in tab.dat

; First we read and store tabbessel.dat
;- 
dt0 = 0.0
if keyword_set (t0) then dt0 = t0
x = [x] ; make x a vector if it is not one yet.
n = (size(x))(1)
size = dblarr(n)
tau_star = 12*nu*t/1.0 + dt0
arg=2.*x/tau_star
b = where(arg GT 709)
b=[b]
if (b[0] NE -1) then arg(b)=709
sigma = beseli(arg,.25)*exp(-(1.+x^2)/tau_star)/tau_star/(x^.25)/!PI
if keyword_set (plot) then begin
    plot, x, sigma, _extra=e
endif
if keyword_set (overplot) then begin
    oplot, x, sigma, _extra=e
endif
return
end
