pro sod2d,nb=nb
if NOT(keyword_set(nb)) then nb=10
@IDL_params.dat
xmin = input_par.range1low
xmax = input_par.range1high
nx = input_par.size1
xvv = (dindgen(2*nx)+.5)/nx*(xmax-xmin)+xmin
xv = (dindgen(nx)+.5)/nx*(xmax-xmin)+xmin
ymin = input_par.range2low
ymax = input_par.range2high
ny = input_par.size2
yv = (dindgen(ny)+.5)/ny*(ymax-ymin)+ymin
window,0
loadct,27
slice,nb=nb,/auto,/box
aslice,field=dens,nb=nb
aslice,field=vx,/vel
aslice,field=vy,/vel,comp=1
;Below we define cutting lines perpendicular to the shock
;and aligned with the shock (to check transverse motions)
ncut=200
cut=dblarr(4,ncut)
cutvel=dblarr(3,ncut)
t=1.2*(dindgen(ncut)/(float(ncut)*.5)-1.)
for j=0,2 do begin
    x0=6-.5*j/3.
    y0=(1-x0/10.)*6.
    x=.6*t+x0
    y=t+y0
    oplot,x,y,line=j+1,thick=2
    xi=(x-min(xv))/(max(xv)-min(xv))*(nx-1)
    yi=(y-min(yv))/(max(yv)-min(yv))*(ny-1)
    cut(j,*)=interpolate(dens,xi,yi)
    x0=0.5*(j-1*0)
    x=dindgen(ncut)/float(ncut)*(xmax-xmin)+xmin
    y=((x0-x)/10.+1.)*6
    oplot,x,y,line=j+1,thick=2
    xi=(x-min(xv))/(max(xv)-min(xv))*(nx-1)
    yi=(y-min(yv))/(max(yv)-min(yv))*(ny-1)
    cutvel(j,*)=interpolate((vx-vy*.6)/sqrt(1.36),xi,yi)
    s=sqrt(x^2+(y-6.)^2)
endfor
; last cut aligned with mesh
tnorm=t*sqrt(1+.6^2)
x=tnorm+10.
xi=(x-min(xv))/(max(xv)-min(xv))*(nx-1)
cut(3,*)=interpolate([dens,dens],xi,xi*0.0+ny/2.)
window,1
;The doubling up of arrays vx, vy and xvv in x is meant to
;account for periodicity in x (the ymax value of the following
;plot is larger than the mesh upper boundary in y).
velovect,[vx,vx],[vy,vy],xvv,yv,/iso,xr=[7,10.8],yr=[.5,3],noclip=0,$
         xtitle='X',ytitle='Y',length=0.7
window,2
loadct,31
!x.range=0 & !y.range=0
solve_riemann_iso,1,.1,0,0,1.0,.05*nb,tnorm,r,u
plot,tnorm,r,/nodata,xtitle='Distance from initial discontinuity',$
     ytitle='Density',charsize=1.3
oplot,tnorm,r,color=195
oplot,-tnorm,cut(3,*),color=155,thick=2
for j=0,2 do begin
    oplot,tnorm,cut(j,*),line=j+1,color=140
endfor
plots,.3,.6
plots,.5,.6,/continue,color=140
xyouts,.6,.6,align=0.0,'Cuts on oblique shock',chars=1.3
plots,.3,.7
plots,.5,.7,/continue,color=195
xyouts,.6,.7,align=0.0,'Analytic solution',chars=1.3
plots,.3,.8
plots,.5,.8,/continue,color=155,thick=2
xyouts,.6,.8,align=0.0,'Cut on aligned shock',chars=1.3
window,3
plot,s,cutvel(0,*),line=1,yr=[-.1,.1],thick=3,charsize=1.3,$
     xtitle='Position along cut',ytitle='Tranverse velocity over sound speed'
for j=1,2 do begin
    oplot,s,cutvel(j,*),line=j+1,color=130+10*j,thick=3
endfor
return
end

