pro solve_riemann_iso, rhoL, rhoR, uL, uR, a, t, x, rho, u
n = (size(x))(1)
rho=x
u=x
getstar_iso, rhoL, rhoR, uL, uR, a, us, rhos
print,'ustar   = ',us
print,'rhostar = ',rhos
for i=0, n-1 do begin
    xt = x(i)/t
    if (xt LT us) then begin
                                ;we are in the star or left region or fan
        if (rhos GT rhoL) then begin ;There is a left shock
            S_shock = uL-a*sqrt(rhos/rhoL)
            if (xt LT S_shock) then begin ;We are at the left of the left shock
                u_godunov = uL
                rho_godunov = rhoL
            endif else begin    ;we are in the star region
                u_godunov = us
                rho_godunov = rhos
            endelse
        endif else begin        ;There is a left rarefaction
            if (xt LT uL-a) then begin	;We are in the left region
                u_godunov = uL
                rho_godunov = rhoL
            endif else begin
                if (xt GT us-a) then begin ;We are in the star region
                    u_godunov = us
                    rho_godunov = rhos
                endif else begin ;We are in the fan
                    u_godunov = a+xt
                    rho_godunov = rhoL*exp((uL-u_godunov)/a)
                endelse
            endelse
        endelse
    endif else begin            ;There is a right shock
        if (rhos GT rhoR) then begin
            S_shock = uR+a*sqrt(rhos/rhoR)
            if (xt GT S_shock) then begin ; we are at the right of the right shock
                u_godunov = uR
                rho_godunov = rhoR
            endif else begin    ; we are in the star region
                u_godunov = us
                rho_godunov = rhos
            endelse
        endif else begin        ; There is a right rarefaction
            if (xt GT uR+a) then begin	; we are in the right part
                u_godunov = uR
                rho_godunov = rhoR
            endif else begin
                if (xt LT us+a) then begin ; we are in the star region
                    u_godunov = us
                    rho_godunov = rhos
                endif else begin ; we are in the fan
                    u_godunov = -a+xt
                    rho_godunov = rhoR*exp(-(uR-u_godunov)/a)
                endelse
            endelse
        endelse
    endelse
    rho(i) = rho_godunov
    u(i) = u_godunov
endfor
return
end
