pro tilt_rect, nb=nb, noplot=noplot, theta0=theta0, field=field, colatitude=colatitude
if (NOT(keyword_set(theta0))) then theta0=0.4
aslice,nb=nb,field=m,coordp=1.0
naz=(size(m))[1]
ncol=(size(m))[2]
az=(dindgen(naz)+.5)/naz*2.0*!PI
col=(dindgen(ncol)+.5)/ncol*!PI
miss = min(m)
n= dblarr(naz,naz)
azimuth    = dblarr(naz)
colatitude = dblarr(naz)
for i=0,naz-1 do begin
    for j =0,naz-1 do begin
        phi_p = (i+.5)*2.0*!PI/naz
        the_p = (j+.5)/naz*!PI
        x = sin(the_p)*cos(phi_p)*cos(theta0)+cos(the_p)*sin(theta0)
        y = sin(the_p)*sin(phi_p)
        phi = atan(y,x)
        if (phi LE 0.0) then phi = phi+2.0*!PI
        theta = acos(cos(the_p)*cos(theta0)-sin(the_p)*sin(theta0)*cos(phi_p))
        x = (phi/2.0/!PI)*naz
        y = (theta-0.05)/(!PI-0.1)*naz
        n(i,j) = interpolate(m,x,y,missing=miss)
        azimuth(i) = phi_p
        colatitude(j) = the_p
    endfor
endfor
field=n
if keyword_set(noplot) then return
contour,n,az,col,/xstyle,/ystyle,/fill,nlev=60, $
  xtitle='Wave Azimuth', ytitle='Wave Colatitude', _extra=e
return
end
