pro tilt_sphere,nb=nb
aslice,nb=nb,field=m,coordp=1.0
@IDL_params.dat
colmin = input_par.range2low
colmax = input_par.range2high
ncol = input_par.size2
;nb of extra rows at the poles:
exr_north=long(colmin/(colmax-colmin)*ncol)
exr_south=long((!PI-colmax)/(colmax-colmin)*ncol)

s0=(size(m))[1]
s1=(size(m))[2]
mlarge = dblarr(s0,s1+exr_north+exr_south)+max(m)
mlarge(*,exr_north:exr_north+s1-1)=m
image = bytscl(mlarge)

MESH_OBJ, 4, vertices, polygons, REPLICATE(0.25, 101, 101)  

oModel = OBJ_NEW('IDLgrModel')  
oPalette = OBJ_NEW('IDLgrPalette')  
oPalette -> LOADCT, 33  
oPalette -> SetRGB, 255, 255, 255, 255  
oImage = OBJ_NEW('IDLgrImage', image, PALETTE = oPalette)  

vector = FINDGEN(101)/100.  
texure_coordinates = FLTARR(2, 101, 101)  
texure_coordinates[0, *, *] = vector # REPLICATE(1., 101)  
texure_coordinates[1, *, *] = REPLICATE(1., 101) # vector  

oPolygons = OBJ_NEW('IDLgrPolygon', SHADING = 1, $  
   DATA = vertices, POLYGONS = polygons, $  
   COLOR = [255, 255, 255], $  
   TEXTURE_COORD = texure_coordinates, $  
   TEXTURE_MAP = oImage, /TEXTURE_INTERP)  
oModel -> ADD, oPolygons  
xobjview,oModel,/block
return
end
