#include "mhd.h"

void CommDeltaSame (lev)
     long lev;
{
  int fieldtype[20]={_Delta_};
  ExecCommSameVar (lev, 1, fieldtype);
}

void CommDeltaUp (lev)
     long lev;
{
  int fieldtype[20]={_Delta_};
  long stride[3], gncell[3];
  long i, j, k, l, m, ind[3];
  real *rho, *v[3], side, *delta[3];
  tGrid_CPU *cpug;
  ExecCommUpVar (lev, 1, fieldtype);
  cpug=Grid_CPU_list;
  while (cpug != NULL) {
    if ((cpug->cpu == CPU_Rank) && (cpug->level == lev+1)) {
      getgridsize (cpug, gncell, stride);
      rho = cpug->Fluid->Density->Field;
      for (l = 0; l < NDIM; l++) {
	v[l] = cpug->Fluid->Velocity->Field[l];
      }
      for (l = 0; l < NDimSplit; l++) {
	delta[l] = cpug->Fluid->Delta->Field[l];
      }
      for (i = 0; i < gncell[0]; i++) {
	ind[0] = i;
	for (j = 0; j < gncell[1]; j++) {
	  ind[1] = j;
	  for (k = 0; k < gncell[2]; k++) {
	    ind[2] = k;
	    m = i*stride[0]+j*stride[1]+k*stride[2];
	    if (cpug->CommDest[m] & DESTGHOSTUP) {
	      for (l = 0; l < NDimSplit; l++) {
		side = (ind[dimsplit[l]] % 2 == 0 ? -1.0 : 1.0);
		rho[m] *= (1.+side*delta[l][m]*.5);
		if (!Refine[dimsplit[l]]) side = 0.0;
		//		delta[l][m] = side*(sqrt(1.0+side*delta[l][m])-1.0);
		delta[l][m] = delta[l][m]/(2.+side*delta[l][m]);
		//delta[l][m] /= 2.0;
		if (!((cpug->DestCommPerp[m]) & (1<<dimsplit[l])) && KEPLERIAN)
		  delta[l][m] = 0.0;
		//rho[m] *= (1.+side*delta[l][m]);
		//		v[dimsplit[l]][m] *= 1.0/(1.+side*delta[l][m]);
	      }
	    }
	  }
	}
      }
    }
    cpug = cpug->next;
  }
}

void PrepareDelta (lev)
     long lev;
{
  tGrid_CPU *cpug;
  long i;
  if (NDimSplit == 0) return;
  cpug=Grid_CPU_list;
  while (cpug != NULL) {
    if ((cpug->cpu == CPU_Rank) && (cpug->level == lev)) {
      SendToCurrent (cpug->Fluid);
      ComputeExternalPotential (cpug->Fluid, 0.0,\
				CurrentFluidPatch->Potential,\
			        SRCGHOSTSAMEEXTEND);
      FillSources2 (PREDICT, SRCGHOSTSAME);
      for (i = 0; i < NDIM; i++)
	if (ZoneSplitting[i])
	  LevSplitZones (i, SRCGHOSTSAME);
      CurrentToPatch (cpug->Fluid);
    }
    cpug = cpug->next;
  }
  CommDeltaSame (lev);
}

void PrepareDeltaUp (lev)
     long lev;
{
  tGrid_CPU *cpug;
  long i;
  if (NDimSplit == 0) return;
  cpug=Grid_CPU_list;
  while (cpug != NULL) {
    if ((cpug->cpu == CPU_Rank) && (cpug->level == lev)) {
      SendToCurrent (cpug->Fluid);
      ComputeExternalPotential (cpug->Fluid, 0.0,\
				CurrentFluidPatch->Potential,\
			        SRCGHOSTUPEXTEND);
      FillSources2 (PREDICT, SRCGHOSTUP);
      for (i = 0; i < NDIM; i++)
	if (ZoneSplitting[i])
	  LevSplitZones (i, SRCGHOSTUP);
      CurrentToPatch (cpug->Fluid);
    }
    cpug = cpug->next;
  }
  CommDeltaUp (lev);
}
