#include "mhd.h"

void FillSlopes () {
  long i, j, k, l, ll, m, n, mp[3], mm[3], ind[3], ip1, ip2, w1, w2, d1, d2;
  FluidWork *fw;
  real *edges[3], *center[3], *rho, *v[3], mup, mum, mu;
  real vp, vm, vc, rhoc, rhop, rhom, *delta[3], *energy;
  real Sm, Sp, Smm, Spp;
  //  real ec, ep, em;
  real *srho[3], *sv[3][3], invdx[3], *invm[3][2], *met[3][2], *se[3];
  real fdx[3], fvel[3], invf;
  real deltac=0.0, deltap=0.0, deltam=0.0, *inter[3];
  long gncell[3], stride[3], ngh[3];
  fw = CurrentFluidPatch;
  getgridsize (fw->desc, gncell, stride);
  rho = fw->Density;
  energy = fw->Energy;
  for (i = 0; i < NDIM; i++) {
    v[i] = fw->Velocity[i];
    edges[i] = fw->desc->Edges[i];
    delta[i] = fw->delta[i];
    invm[i][0] = fw->desc->InvMetric[i][0];
    invm[i][1] = fw->desc->InvMetric[i][1];
    met[i][0] = fw->desc->Metric[i][0];
    met[i][1] = fw->desc->Metric[i][1];
    center[i] = fw->desc->Center[i];
    srho[i] = fw->SlopeDensity[i];
    se[i]  = fw->SlopeEnergy[i];
    inter[i] = fw->desc->InterSurface[i];
    for (j = 0; j < NDIM; j++) {
      sv[i][j] = fw->SlopeVelocity[i][j];
    }
  }
  for (i = 0; i < 3; i++)
    ngh[i] = (Nghost[i] > 0 ? Nghost[i]-1 : 0);
  for (n = 0; n < NDIM; n++) {
    ip1 = (n == 0);
    ip2 = 2 - (n == 2);
    for (k = ngh[2]; k < gncell[2]-ngh[2]; k++) {
      ind[2] = k;
      for (j = ngh[1]; j < gncell[1]-ngh[1]; j++) {
	ind[1] = j;
	for (i = ngh[0]; i < gncell[0]-ngh[0]; i++) {
	  ind[0] = i;
	  m = i*stride[0]+j*stride[1]+k*stride[2];
	  for (ll = 0; ll < NDIM; ll++) {
	    mp[ll] = m+stride[ll];
	    mm[ll] = m-stride[ll];
	  }
	  invdx[0] = 1./(edges[0][i+1]-edges[0][i]);
	  fdx[0] = invm[0][0][j] * invm[0][1][k];
	  invdx[0] *= fdx[0];
	  if (NDIM > 1) {
	    invdx[1] = 1./(edges[1][j+1]-edges[1][j]);
	    fdx[1] = invm[1][0][i] * invm[1][1][k];
	    invdx[1] *= fdx[1];
	  }
	  if (NDIM > 2) {
	    invdx[2] = 1./(edges[2][k+1]-edges[2][k]);
	    fdx[2] = invm[2][0][i] * invm[2][1][j];
	    invdx[2] *= fdx[2];
	  }
	  for (l = 0; l < NDIM; l++) {
	    if (n == 0) {		/* Slopes of scalar quantities are evaluated only once */
	      rhoc = rho[m];
	      rhop = rho[mp[l]];
	      rhom = rho[mm[l]];
	      if (ZoneSplitting[l]) {
		deltap = delta[l][mp[l]];
		deltam = delta[l][mm[l]];
		deltac = delta[l][m];
		rhop = rhop*(1.0-deltap)-rhoc*(1.0+deltac);
		rhom = rhom*(1.0+deltam)-rhoc*(1.0-deltac);
		rhoc = 0.0;
	      }
	      srho[l][m] = invdx[l]*TVDslope(rhop-rhoc,rhoc-rhom);
	      //	  if (!Isothermal) {
	      //	    ec = energy[m];
	      //	    ep = energy[mp[l]];
	      //	    em = energy[mm[l]];
	      //	    se[l][m] = invdx[l]*TVDslope(ep-ec,ec-em);
	      //	  }
	    }
	    invf = 1.0;
	    w1 = ind[ip1];
	    w2 = ind[ip2];
	    d1 = (ip1 == l);
	    d2 = (ip2 == l);
	    vc = v[n][m];
	    vp = v[n][mp[l]];
	    vm = v[n][mm[l]];
	    fvel[0] = met[n][0][w1] * met[n][1][w2];
	    fvel[1] = met[n][0][w1+d1] * met[n][1][w2+d2];
	    fvel[2] = met[n][0][w1-d1] * met[n][1][w2-d2];
	    if (fvel[0] != fvel[1]) { /* Means that the velocity considered is an angular one */
	      /* in which case we consider rather the associated momentum */
	      /* One test only suffices. This happens only in a transverse case (n != l), */
	      /* which is why  we do not need consider  this in a zone
		 splitting case */
	      fvel[0] *= fvel[0];
	      fvel[1] *= fvel[1];
	      fvel[2] *= fvel[2];
	      invf = fdx[n];
	    }
	    vc *= fvel[0];
	    vp *= fvel[1];
	    vm *= fvel[2];
	    if ((n == l) && (ZoneSplitting[l])) {
	      Sp = inter[l][mp[l]];
	      Sm = inter[l][m];
	      Spp = Sp+(center[l][mp[l]]-edges[l][ind[l]+1])*invdx[l]*(Sp-Sm);
	      Smm = Sm+(center[l][mm[l]]-edges[l][ind[l]])*invdx[l]*(Sp-Sm);
	      /* In principle  one could  have directly access  to Spp
		 and Smm.  However for the last  zone (in the rightmost  ghost), Spp is
		 not defined, which  leads to a mismatch between  results obtained with
		 different   processors   numbers  when   using   the  zone   splitting
		 tehcnique. This is why we use this 1st order extrapolation to estimate
		 the  extreme intersurface  surfaces. Also  note that  although  Smm is
		 always defined  (as inter[mm[l]]), we do  not pick it  up directly but
		 rather use  the same  kind of extrapolation  as for Spp,  for symmetry
		 reasons. Otherwise e.g.  a run  in spherical coordinates for which the
		 equator would be  a plane of symmetry of  the initial conditions would
		 eventually break down this symmetry, which is not desirable. */ 
	      mup = (Sp-Spp)/(Sp+Spp);
	      mu  = (Sm-Sp)/(Sm+Sp);
	      mum = (Smm-Sm)/(Smm+Sm);
	      vp = vp*(1.0-mup)/(1.0-deltap)-vc*(1.0+mu)/(1.0+deltac);
	      vm = vm*(1.0+mum)/(1.0+deltam)-vc*(1.0-mu)/(1.0-deltac);
	      vc = 0.0;
	    }
	    sv[l][n][m] = invf*invdx[l]*TVDslope(vp-vc,vc-vm);
	  }
	}
      }
    }
  }
}
	
