#include "mhd.h"

void FillSources (flag, loc) 
     long flag, loc;
{
  long i, j, k, l, m, mp[3], mm[3], smp, smm, Size;
  FluidWork *fw;
  real *inter[3], *center[3], *invvol, *rho, *pot, *v[3];
  real *sv[3], *met[3][2], *acc[3];
  real metric_coef=1.0;
  real sinvdx, vphi, vtheta, rad, cot, sine, *invm[3][2];
  real *srcrho, dsurf, *sinecol;
  long gncell[3], stride[3], ngh[3], ind[3], ip1, ip2;
  fw = CurrentFluidPatch;
  getgridsize (fw->desc, gncell, stride);
  Size = gncell[0]*gncell[1]*gncell[2];
  rho = fw->Density;
  pot = fw->Potential;
  invvol = fw->desc->InvVolume;
  srcrho = fw->SourceRhoPred;
  for (i = 0; i < NDIM; i++) {
    v[i] = fw->Velocity[i];
    sv[i] = fw->SourceVelocity[i];
    acc[i] = fw->Accel[i];
  }
  for (i = 0; i < 3; i++) {
    inter[i] = fw->desc->InterSurface[i];
    center[i] = fw->desc->Center[i];
    invm[i][0] = fw->desc->InvMetric[i][0];
    invm[i][1] = fw->desc->InvMetric[i][1];
    met[i][0] = fw->desc->Metric[i][0];
    met[i][1] = fw->desc->Metric[i][1];
  }
  sinecol = met[_Azimuthal_][_Colatitude_ > _Radial_];
  for (i = 0; i < 3; i++)
    ngh[i] = (Nghost[i] > 0 ? Nghost[i]-1 : 0);
  if (flag == PREDICT) {
    for (l = 0; l < NDIM; l++) {
      for (k = ngh[2]; k < gncell[2]-ngh[2]; k++) {
	for (j = ngh[1]; j < gncell[1]-ngh[1]; j++) {
	  if (l == 0) metric_coef = invm[0][0][j] * invm[0][1][k];
	  for (i = ngh[0]; i < gncell[0]-ngh[0]; i++) {
	    if (l == 2) metric_coef = invm[2][0][i] * invm[2][1][j];
	    if (l == 1) metric_coef = invm[1][0][i] * invm[1][1][k];
	    m = i*stride[0]+j*stride[1]+k*stride[2];
	    if (fw->desc->CommSource[m] & loc) {
	      if (EXTERNALPOTENTIAL == YES) {
		smp = m+stride[l];
		smm = m-stride[l];
		sinvdx = 1.0/(center[l][smp]-center[l][smm]);
		sinvdx *= metric_coef;
		if (KEPLERIAN)
		  sv[l][m] = pot[m]*pot[m]*(1./pot[smp]-1./pot[smm])*sinvdx;
		else
		  sv[l][m] = (pot[smm]-pot[smp])*sinvdx;
	      } else {
		sv[l][m] = 0.0;
	      }
	      if (GridFriction[l] != 0.0)
		sv[l][m] -= v[l][m]*GridFriction[l];
	    }
	  }
	}
      }
    }
  }

  if (flag == PREDICT)
    memcpy (acc[0], sv[0], NDIM*Size*sizeof(real));
  else
    memcpy (sv[0], acc[0], NDIM*Size*sizeof(real));

  for (k = ngh[2]; k < gncell[2]-ngh[2]; k++) {
    ind[2] = k;
    for (j = ngh[1]; j < gncell[1]-ngh[1]; j++) {
      ind[1] = j;
      for (i = ngh[0]; i < gncell[0]-ngh[0]; i++) {
	ind[0] = i;
	m = i*stride[0]+j*stride[1]+k*stride[2];
	if (fw->desc->CommSource[m] & loc) {
	  for (l = 0; l < 3; l++) { /* 3, not NDIM */
	    mp[l] = m+stride[l];
	    mm[l] = m-stride[l];
	  }
	  if (CoordType != CARTESIAN) {
	    vphi = vtheta = 0.0;
	    if (_Azimuthal_ < NDIM)
	      vphi = v[_Azimuthal_][m];
	    vphi += OMEGAFRAME;
	    rad = center[_Radial_][m];
	    if (CoordType == SPHERICAL) {
	      sine = sinecol[ind[_Colatitude_]];
	      vphi *= sine;
	      if (_Colatitude_ < NDIM)
		vtheta = v[_Colatitude_][m];
	      if (_Radial_ < NDIM)
		sv[_Radial_][m] += rad*(vphi*vphi+vtheta*vtheta);
	      if (_Colatitude_ < NDIM) {
		cot = (inter[_Colatitude_][mp[_Colatitude_]]-inter[_Colatitude_][m])*invvol[m]*rad;	
		sv[_Colatitude_][m] += rad*vphi*vphi*cot;
	      }
	    } else {
	      if (_Radial_ < NDIM)
		sv[_Radial_][m] += rad*vphi*vphi;
	    }
	  }
	}
      }
    }
  }
  if (flag == PREDICT) {
    for (i = 0; i < Size; i++) 
      srcrho[i] = 0.0;
    for (l = 0; l < NDIM; l++) {
      ip1 = (l == 0);
      ip2 = 2 - (l == 2);
      for (k = ngh[2]; k < gncell[2]-ngh[2]; k++) {
	ind[2] = k;
	for (j = ngh[1]; j < gncell[1]-ngh[1]; j++) {
	  ind[1] = j;
	  for (i = ngh[0]; i < gncell[0]-ngh[0]; i++) {
	    ind[0] = i;
	    m = i*stride[0]+j*stride[1]+k*stride[2];
	    if (fw->desc->CommSource[m] & loc) {
	      if (CoordType != CARTESIAN) {
		smp = m+stride[l];
		metric_coef = met[l][0][ind[ip1]]*met[l][1][ind[ip2]];
		dsurf = inter[l][smp]-inter[l][m];
		srcrho[m] += v[l][m]*dsurf*metric_coef;
	      }
	    }
	  }
	}
      }
    }
    for (i = 0; i < Size; i++) 
      srcrho[i] *= rho[i]*invvol[i];
  }
}

void FillSources2 (flag, loc) 
     long flag, loc;
{
  long i, j, k, l, m, mp[3], mm[3], smp, smm, Size;
  FluidWork *fw;
  real *inter[3], *center[3], *invvol, *rho, *pot, *v[3];
  real *sv[3], *met[3][2], *acc[3];
  real metric_coef=1.0;
  real sinvdx, vphi, vtheta, rad, cot, sine, *invm[3][2];
  real *srcrho, dsurf, *sinecol;
  long gncell[3], stride[3], ngh[3], ind[3], ip1, ip2;
  fw = CurrentFluidPatch;
  getgridsize (fw->desc, gncell, stride);
  Size = gncell[0]*gncell[1]*gncell[2];
  rho = fw->Density;
  pot = fw->Potential;
  invvol = fw->desc->InvVolume;
  srcrho = fw->SourceRhoPred;
  for (i = 0; i < NDIM; i++) {
    v[i] = fw->Velocity[i];
    sv[i] = fw->SourceVelocity[i];
    acc[i] = fw->Accel[i];
  }
  for (i = 0; i < 3; i++) {
    inter[i] = fw->desc->InterSurface[i];
    center[i] = fw->desc->Center[i];
    invm[i][0] = fw->desc->InvMetric[i][0];
    invm[i][1] = fw->desc->InvMetric[i][1];
    met[i][0] = fw->desc->Metric[i][0];
    met[i][1] = fw->desc->Metric[i][1];
  }
  sinecol = met[_Azimuthal_][_Colatitude_ > _Radial_];
  for (i = 0; i < 3; i++)
    ngh[i] = (Nghost[i] > 0 ? Nghost[i]-1 : 0);
  if (flag == PREDICT) {
    for (l = 0; l < NDIM; l++) {
      for (k = ngh[2]; k < gncell[2]-ngh[2]; k++) {
	for (j = ngh[1]; j < gncell[1]-ngh[1]; j++) {
	  if (l == 0) metric_coef = invm[0][0][j] * invm[0][1][k];
	  for (i = ngh[0]; i < gncell[0]-ngh[0]; i++) {
	    if (l == 2) metric_coef = invm[2][0][i] * invm[2][1][j];
	    if (l == 1) metric_coef = invm[1][0][i] * invm[1][1][k];
	    m = i*stride[0]+j*stride[1]+k*stride[2];
	    if (fw->desc->CommSource[m] & loc) {
	      if (EXTERNALPOTENTIAL == YES) {
		smp = m+stride[l];
		smm = m-stride[l];
		sinvdx = 1.0/(center[l][smp]-center[l][smm]);
		sinvdx *= metric_coef;
		if (KEPLERIAN)
		  sv[l][m] = pot[m]*pot[m]*(1./pot[smp]-1./pot[smm])*sinvdx;
		else
		  sv[l][m] = (pot[smm]-pot[smp])*sinvdx;
	      } else {
		sv[l][m] = 0.0;
	      }
	      if (GridFriction[l] != 0.0)
		sv[l][m] -= v[l][m]*GridFriction[l];
	    }
	  }
	}
      }
    }
  }

  if (flag == PREDICT)
    memcpy (acc[0], sv[0], NDIM*Size*sizeof(real));
  else
    memcpy (sv[0], acc[0], NDIM*Size*sizeof(real));

  for (k = ngh[2]; k < gncell[2]-ngh[2]; k++) {
    ind[2] = k;
    for (j = ngh[1]; j < gncell[1]-ngh[1]; j++) {
      ind[1] = j;
      for (i = ngh[0]; i < gncell[0]-ngh[0]; i++) {
	ind[0] = i;
	m = i*stride[0]+j*stride[1]+k*stride[2];
	if (fw->desc->CommSource[m] & loc) {
	  for (l = 0; l < 3; l++) { /* 3, not NDIM */
	    mp[l] = m+stride[l];
	    mm[l] = m-stride[l];
	  }
	  if (CoordType != CARTESIAN) {
	    vphi = vtheta = 0.0;
	    if (_Azimuthal_ < NDIM)
	      vphi = v[_Azimuthal_][m];
	    vphi += OMEGAFRAME;
	    rad = center[_Radial_][m];
	    if (CoordType == SPHERICAL) {
	      sine = sinecol[ind[_Colatitude_]];
	      vphi *= sine;
	      if (_Colatitude_ < NDIM)
		vtheta = v[_Colatitude_][m];
	      if (_Radial_ < NDIM)
		sv[_Radial_][m] += rad*(vphi*vphi+vtheta*vtheta);
	      if (_Colatitude_ < NDIM) {
		cot = (inter[_Colatitude_][mp[_Colatitude_]]-inter[_Colatitude_][m])*invvol[m]*rad;	
		sv[_Colatitude_][m] += rad*vphi*vphi*cot;
	      }
	    } else {
	      if (_Radial_ < NDIM)
		sv[_Radial_][m] += rad*vphi*vphi;
	    }
	  }
	}
      }
    }
  }
  if (flag == PREDICT) {
    for (i = 0; i < Size; i++) 
      srcrho[i] = 0.0;
    for (l = 0; l < NDIM; l++) {
      ip1 = (l == 0);
      ip2 = 2 - (l == 2);
      for (k = ngh[2]; k < gncell[2]-ngh[2]; k++) {
	ind[2] = k;
	for (j = ngh[1]; j < gncell[1]-ngh[1]; j++) {
	  ind[1] = j;
	  for (i = ngh[0]; i < gncell[0]-ngh[0]; i++) {
	    ind[0] = i;
	    m = i*stride[0]+j*stride[1]+k*stride[2];
	    if (fw->desc->CommSource[m] & loc) {
	      if (CoordType != CARTESIAN) {
		smp = m+stride[l];
		metric_coef = met[l][0][ind[ip1]]*met[l][1][ind[ip2]];
		dsurf = inter[l][smp]-inter[l][m];
		srcrho[m] += v[l][m]*dsurf*metric_coef;
	      }
	    }
	  }
	}
      }
    }
    for (i = 0; i < Size; i++) 
      srcrho[i] *= rho[i]*invvol[i];
  }
}
