#include "mhd.h"

void gfo (beam, dt)
     Beam *beam;
     real dt;
{
  long k, length;
  boolean zs;
  real mu, *inter, *delta;
  length = beam->length;
  delta = beam->delta;
  inter = beam->intersurface;
  zs = (ZoneSplitting[beam->dim[0]] == TRUE);
  for (k = 1; k < length; k++) {
    beam->rhoL[k] = beam->rho[k-1];
    beam->rhoR[k] = beam->rho[k];
    beam->uL[k] = beam->u[k-1];
    beam->uR[k] = beam->u[k];
    if (zs) {
      mu = (inter[k]-inter[k+1])/(inter[k]+inter[k+1]);
      beam->rhoR[k] *= (1.0-delta[k]);
      beam->uR[k] *=  (1.0-mu)/(1.0-delta[k]);
      mu = (inter[k-1]-inter[k])/(inter[k-1]+inter[k]);
      beam->rhoL[k] *= (1.0+delta[k-1]);
      beam->uL[k] *=  (1.0+mu)/(1.0+delta[k-1]);
    }
    beam->v_perp_L[0][k] = beam->v_perp[0][k-1];
    beam->v_perp_R[0][k] = beam->v_perp[0][k];
    beam->v_perp_L[1][k] = beam->v_perp[1][k-1];
    beam->v_perp_R[1][k] = beam->v_perp[1][k];
  }
  AdjustBeamBoundaries (beam);
}
