#include "mhd.h"

long GlobalInit (argc, argv)
     int argc;
     char *argv[];
{
  long NbRestart=0;
  char parameters[MAXLINELENGTH];
  GridFileInfo grids[MAXGRIDS];
  tGrid *grid;
  srand (CPU_Rank);
  ReadDefaultInOut (); 
  NbRestart = switches (argc, argv, parameters); /* We parse the command line */
  /* This gives us 'parameters', the name of the parameter file */
  ReadVariables (parameters);	/* which we parse. */
  SubsDef ("output directory", OUTPUTDIR, DefaultOut);
  FlushLog ();			/* Since we now know where OUTPUTDIR
				   is, we can write the log files
				   (info, warning and error), see
				   log.c */
  checkpara ();			/* We check whether the user has not
				   mistakingly started the sequential
				   build with an MPI command */
  findcodeinit ();	  /* We check whether we know the init code */
  DumpInitCode (); /* We write the initial conditions to 'init.log' */
  findcodepot ();	  /* We check whether we know the potential code */
  DumpPotCode (); /* We write the potential expression to 'pot.log' */
  DumpParameters ();		/* Write input parameters to output directory */
  DumpSources (argc, argv);	/* Write hidden tarball source file to
				   output directory */
  TestEndian ();		/* so that IDL knows whether to swap
				   endians during post-processing */
  if (KEPLERIAN) keplerian_create ();
  if (Merge) merge(NbRestart);
  if (AddSubPatch) refine();	/* Everything is defined in SubPatchInfo */
  if (!Restart)
    ScanGridFile (GRIDFILE);
  else {
    ReadGrids (NbRestart, grids);
    ConstructGrids (grids);
    CurrentOutputNumber = NbRestart;
  }
  grid = GridList;
  while (grid != NULL) {splitgrid (grid); grid = grid->next;}
  BuildCommunicators ();
  InitWholeHierarchy (NbRestart);
  if (RayTracing) Ray_Tracing ();
  return NbRestart;
}
