#include "mhd.h"

void LevSplitZones (dim, flag)
     long dim;
     char flag;
{
  long i,j,k,m,mp,mm,dp1,dp2;
  long stride[3], gncell[3], nghi[3], nghs[3], ind[3];
  real *invvol, *surf, *vel, *delta;
  real *metric[3][2];
  real asqp, asqm, F, D, m2, sp, sm, mu;
  FluidWork *fw;
  real *src, *csq, v;
  fw = CurrentFluidPatch;
  getgridsize (fw->desc, gncell, stride);
  src = fw->SourceVelocity[dim];
  csq = fw->Energy;
  invvol = fw->desc->InvVolume;
  surf = fw->desc->InterSurface[dim];
  vel = fw->Velocity[dim];
  delta = fw->delta[dim];
  dp1 = (dim == 0);
  dp2 = 2 - (dim == 2);
  for (i = 0; i < 3; i++) {
    nghs[i] = nghi[i] = (Nghost[i] > 1 ? Nghost[i]-(i != dim) : 0);
    metric[i][0] = fw->desc->Metric[i][0];
    metric[i][1] = fw->desc->Metric[i][1];
  }
  if (fw->desc->iface[dim][INF] == 0) nghi[dim] = Nghost[dim]-1;
  if (fw->desc->iface[dim][SUP] == 0) nghs[dim] = Nghost[dim]-1;
  //nghi[dim]=Nghost[dim]-1;
  /* The 3 above lines mean that we evaluate \delta up to the first */
  /* row of ghosts, except along the direction of \delta, for which we */
  /* do not want to overwrite what might have previously be written */
  /* during the delta communications. However if the boundary is a */
  /* CPU-to-CPU boundary, then we do have to evaluate the first row */
  /* of ghosts along delta direction as well, this is important to */
  /* get results independent of the number of pe's (we want the cross terms) */
  for (k = nghi[2]; k < gncell[2]-nghs[2]; k++) {
    ind[2] = k;
    for (j = nghi[1]; j < gncell[1]-nghs[1]; j++) {
      ind[1] = j;
      for (i = nghi[0]; i < gncell[0]-nghs[0]; i++) {
	ind[0] = i;
	m  = i*stride[0]+j*stride[1]+k*stride[2];
	if (fw->desc->CommSource[m] & flag) {
	  mp = m+stride[dim];
	  mm = m-stride[dim];
	  asqp = .5*(csq[mp]+csq[m]);
	  asqm = .5*(csq[mm]+csq[m]);
	  D  = (asqm-asqp)/(asqm+asqp);
	  sp = surf[mp];
	  sm = surf[m];
	  mu = (sm-sp)/(sm+sp);
	  F  = 2.0*src[m]/((sp+sm)*(asqp+asqm)*invvol[m]);
	  F += D;
	  v = vel[m];
	  v *= metric[dim][dp1][ind[dp1]]*metric[dim][dp2][ind[dp2]];
	  m2 = 8.*sp*sm*v*v/((sp+sm)*(sp+sm)*(asqp+asqm));
	  delta[m] = findrootexact (F, m2, mu);
	  if (fabs(delta[m]) > .99999) delta[m] = .99999*(delta[m] > 0.0 ? 1.0 : -1.0);
	}
      }
    }
  }
}

