#include "mhd.h"

void PressureCorrection (dt)
     real dt;
{
  FluidWork *fw;
  real *gp[3], *rho;
  real *center[3], *_radius, *_colatitude;
  real *vel[3];
  real *inter[3], *invvol;
  long i, j, k, gncell[3], stride[3], dim;
  long m, mp, l;
  real metric;
  fw = CurrentFluidPatch;
  rho = fw->Density;
  getgridsize (fw->desc, gncell, stride);
  for (dim = 0; dim < 3; dim++) {
    gp[dim] = fw->GodPressure[dim];
  }
  for (dim = 0; dim < 3; dim++) {
    center[dim] = fw->desc->Center[dim];
    vel[dim] = fw->Velocity[dim];
    inter[dim] = fw->desc->InterSurface[dim];
  }
  _radius = center[_Radial_];
  _colatitude = center[_Colatitude_];
  invvol = fw->desc->InvVolume;
  for (l = 0; l < NDIM; l++) {
    for (k = Nghost[2]; k < gncell[2]-Nghost[2]; k++) {
      for (j = Nghost[1]; j < gncell[1]-Nghost[1]; j++) {
	for (i = Nghost[0]; i < gncell[0]-Nghost[0]; i++) {
	  m = i*stride[0]+j*stride[1]+k*stride[2];
	  metric = 1.0;
	  if ((CoordType == CYLINDRICAL)  && (l == _Azimuthal_))
	    metric = _radius[m];
	  if ((CoordType == SPHERICAL) && (l == _Azimuthal_))
	    metric = _radius[m]*sin(_colatitude[m]);
	  if ((CoordType == SPHERICAL) && (l == _Colatitude_))
	    metric = _radius[m];
	  mp = m+stride[l];
	  vel[l][m] += .5*(gp[l][mp]+gp[l][m])*				\
	    (inter[l][mp]-inter[l][m])*invvol[m]*dt/(rho[m]*metric);
	}
      }
    }
  }
}

