#include "mhd.h"

void Source (dt)
     real dt;
{
  FluidWork *fw;
  real *center[3];
  real *vel[3];
  long i, j, k, gncell[3], stride[3], dim;
  long m, l;
  real metric;
  fw = CurrentFluidPatch;
  getgridsize (fw->desc, gncell, stride);
  for (dim = 0; dim < 3; dim++) {
    center[dim] = fw->desc->Center[dim];
    vel[dim] = fw->Velocity[dim];
  }
  for (l = 0; l < NDIM; l++) {
    for (k = Nghost[2]; k < gncell[2]-Nghost[2]; k++) {
      for (j = Nghost[1]; j < gncell[1]-Nghost[1]; j++) {
	for (i = Nghost[0]; i < gncell[0]-Nghost[0]; i++) {
	  m = i*stride[0]+j*stride[1]+k*stride[2];
	  metric = 1.0;
	  if (CoordType == CYLINDRICAL) {
	    if (l == _Azimuthal_) metric = center[_Radial_][m];
	  }
	  if (CoordType == SPHERICAL) {
	    if (l == _Azimuthal_) metric = center[_Radial_][m]*sin(center[_Colatitude_][m]);
	    if (l == _Colatitude_) metric = center[_Radial_][m];
	  }
	  vel[l][m] += fw->SourceVelocity[l][m]*dt/metric;
	}
      }
    }
  }
  if (fabs(DRIFTVELOCITY) > 1e-10)
    DiskRadialDrift(dt);
}
